using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;
using MikuMikuDance.XNA;
using MikuMikuDance.XNA.Model;
using MikuMikuDance.XNA.Accessory;
using MikuMikuDance.XNA.Motion;
using MikuMikuDance.XNA.Model.ModelData;

namespace MikuMikuDanceXNADemo4
{
    //アクセサリ

    /// <summary>
    /// MikuMikuDance for XNAのデモ
    /// このデモでは
    /// -アクセサリの読み込み
    /// -アクセサリをモデルにセットする
    /// -screen.bmpを要求する特殊アクセサリ(付属モデルのステージとか)の処理方法
    /// が書かれています
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        //MikuMikuDance for XNA
        MikuMikuDanceXNA mmd;
        //MMDモデルデータ
        MMDModel model;
        //MMDモーションデータ
        MMDMotion motion;
        //MMDアクセサリデータ
        MMDAccessory stage, negi;
        //スクリーンマネージャ
        ScreenManager screenManager;
        
        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            //デバイスがMMDXの必要条件を満たしているかチェック
            MikuMikuDanceXNA.InitialSetup(this, graphics, true);
            Content.RootDirectory = "Content";
            
        }

        protected override void Initialize()
        {
            base.Initialize();
        }

        /// <summary>
        /// LoadContent関数
        /// 各種ロード処理はここでロードを行っておくと良い
        /// </summary>
        protected override void LoadContent()
        {
            //MikuMikuDanceXNAを作成する
            mmd = new MikuMikuDanceXNA(this);
            //プロジェクトのContent内に追加してあるMiku.pmdモデルをロードする
            //ロードはMikuMikuDanceXNA.LoadModel関数で行う
            //(モデルデータはあにまさ氏よりお借りしました。このモデルファイルはMITライセンス適応外です)
            model = mmd.LoadModel("Miku", this, QuatTransform.Identity);
            //同じくContent内に追加してあるstage.x,negi.xアクセサリをロードする
            //(アクセサリデータはあにまさ氏よりお借りしました。このモデルファイルはMITライセンス適応外です)
            stage = mmd.LoadAccessory("stage01", this, Matrix.Identity);//プロセッサはMikuMikuDanceアクセサリを指定
            negi = mmd.LoadAccessory("negi", this, Matrix.Identity);//プロセッサはMikuMikuDanceアクセサリを指定
            //アクセサリを持たせる用のnegi-vac.vacをロードする
            MMD_VAC vac = mmd.LoadVAC("negi-vac");
            //モデルにVACを指定することで持たせる(Matrixでも指定可)
            model.SetAccessory(negi, vac);
            
            //モーションロード
            motion = mmd.LoadMotion("TrueMyHeart");
            //モデルのプレイヤーを呼び出し
            //モーションを0番トラックにセットする
            model.Player.SetMotion(0, motion, true);
            //スクリーンマネージャのセットアップ
            screenManager = new ScreenManager(graphics.GraphicsDevice);
            //MMDXにスクリーンマネージャを登録
            mmd.ScreenManager = screenManager;
        }

        /// <summary>
        /// UnloadContent関数
        /// アンロードが必要な物はここでアンロードを行う
        /// </summary>
        protected override void UnloadContent()
        {
        }

        /// <summary>
        /// アップデート関数
        /// 毎フレーム処理する描画以外のコードをここに記述する
        /// </summary>
        /// <param name="gameTime">現在の時間のスナップショットを表すオブジェクト</param>
        protected override void Update(GameTime gameTime)
        {
            //XBoxコントローラーのBackボタンを押したら終了
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();
            //キーボードのEscキーを押したら終了
            if (Keyboard.GetState().IsKeyDown(Keys.Escape))
                this.Exit();
            //エンターキーorAボタンを押したとき
            if (Keyboard.GetState().IsKeyDown(Keys.Enter) || GamePad.GetState(PlayerIndex.One).Buttons.A == ButtonState.Pressed)
            {
                //現在再生中でなければ
                if (!model.Player.IsPlay(0))
                {
                    model.Player.Reset(0);//リセット
                    //0番トラックにセットされているモーションを再生する
                    model.Player.Start(0, false);
                }
            }

            //モデルの再生処理はDrawableGameComponentを継承しているため
            //XNAにより自動で処理が行われる

            //XNA内部のUpdate処理を行う
            base.Update(gameTime);
        }

        /// <summary>
        /// Draw関数
        /// 毎フレーム処理する描画コードをここに記述する
        /// </summary>
        /// <param name="gameTime">現在の時間のスナップショットを表すオブジェクト</param>
        protected override void Draw(GameTime gameTime)
        {
            //Draw処理ではスクリーン処理を行う(この処理は自前で行う必要がある)
            //基本的な流れは
            //1.スクリーンマネージャのbeginを呼び出す
            //2.base.Drawや他の描画を呼び出して書き込む
            //3.スクリーンマネージャのendを呼び出す
            //4.スクリーンマネージャをフリップする

            //スクリーン用キャプチャ開始
            screenManager.Begin(GraphicsDevice);
            //画面をWhite色で消去する
            GraphicsDevice.Clear(Color.White);
            
            //モデルはDrawableGameComponentを継承しているため
            //XNAにより自動で描画される

            //XNA内部のDraw処理を行う
            base.Draw(gameTime);
            //スクリーンキャプチャを終了し、キャプチャ済みの画面を画面に描画
            screenManager.End(GraphicsDevice);
            //spriteBatchでシーンが荒れているので元に戻すコード(SaveStateMode.SaveStateを使わないのはひにけにXNA(http://blogs.msdn.com/ito/archive/2007/03/13/spritebatch-part2.aspx)を参照)
            //MMDXでは各モデル、アクセサリ描画前に自動で設定するコードを書いているので、自動で戻ります。
#if false
            GraphicsDevice.RenderState.DepthBufferEnable = true;
            GraphicsDevice.RenderState.AlphaTestEnable = false;
            GraphicsDevice.RenderState.AlphaBlendEnable = false;
            GraphicsDevice.SamplerStates[0].AddressU = TextureAddressMode.Wrap;
            GraphicsDevice.SamplerStates[0].AddressV = TextureAddressMode.Wrap;
#endif
        }
    }
}
